#include <unistd.h>
#include <asm/unistd.h>
#include <fcntl.h>

void __akvs_probe(const char* id, char type, char direction, char* file) {
    static int fd = -1;
#define AKVS_PROBE_BUFSIZE 32+5
    char buf[AKVS_PROBE_BUFSIZE];
#undef AKVS_PROBE_BUFSIZE
    int i = 0;
    if (fd == -1) {
	fd = syscall(__NR_openat, AT_FDCWD, file, O_WRONLY|O_APPEND|O_CREAT, 0644);
    }
    if (fd > 0) {
	while (id[i] != '\0') {
	    buf[i] = id[i];
	    i++;
	}
	buf[i++] = ':';
	buf[i++] = type;
	buf[i++] = ':';
	buf[i++] = direction;
	buf[i++] = '\n';
	syscall(__NR_write, fd, buf, i);
	syscall(__NR_fsync, fd);
    }
}

strong_alias (__akvs_probe, _akvs_probe);
